// Game of Nim
// by SomeGuy
//
// v1.0
//
// COPYRIGHT:
// This script, from http://ss.deviatenow.com, is protected by this licence:
// CC BY-SA 4.0, see http://creativecommons.org/licenses/by-sa/4.0/
// This copyright refers only to this script itself; it does not include any other included resources
// (images, music, sounds, etc.) which remain the property of their owners.
//

setInfos(6, "Nim", "A challenging game of Nim against a Mistress.", "SomeGuy22006", "v1.0", 0xFFFFFF, "en", ["game", "spanking", "denial", "cbt", "pain"]);

def counters = 13
def choice
def turn =1
def MistressSkill=10
def validIn
def PunishmentRecord = [0,0,0]
def winReward
def winstring
def losestring
def punishment
def playAgain=1
def gameDiff=1
def endchance=8
def gamesplayed=0
def PicNo

// Change current image
def setPic = {type->
if (type==1) {
	PicNo=getRandom(5)+1
	if (gameDiff==2) {
		PicNo=getRandom(9)+1
		if (PicNo<=2) {
			setImage("Nim/Strip"+(PicNo+4+getRandom(3))+".jpg")
		} else {	
			PicNo=getRandom(5)+1	
			setImage("Nim/Nim"+PicNo+".jpg")
		}
	} else {
		PicNo=getRandom(5)+1
		setImage("Nim/Nim"+PicNo+".jpg")
	}
} else if (type==2) {
	PicNo=getRandom(4)+1
	setImage("Nim/Punish"+PicNo+".jpg")
}
}


setImage("Nim/Nim1.jpg")

// Set the number of counters for current game
def setCounters = { ->
def countersIn
if (gameDiff==2) {
	countersIn=getRandom(12)+9
	show("To mix things up let's play with a random number of counters. We'll use "+countersIn+".")
	showButton("OK")

} else {
	def validCounters=0

	while (validCounters==0) {
		countersIn = getInteger("How many counters should we play with? Choose between 9 and 20.",13);
		if (countersIn<9 || countersIn>20) {
			validCounters=0
		} else {
			validCounters=1
		}

}
}
return countersIn
}


// Hand out the spanking punishment
def punish = { text, spanks,type,bpm ->
	def speed = 60/bpm
	show(text+"\n\n"+type+": ")
	wait(2)
	for (def x=1;x<=spanks;x++) {
		show(text+"\n\n"+type+": "+x)
		playBackgroundSound("swat.wav")
		wait(speed)
	}

}

// Apply the losing punishments
def Finalpunishment= { punishments ->
if (punishments[0]>0) {
setPic(2)
	show("So you have "+punishments[0]+" spanks due. Let's get to it.")
	showButton("Ready")
	punish("Spank those cheeks!", punishments[0],"Spanks", 80)
}
if (punishments[1]>0) {
setPic(2)
	show("You owe me "+punishments[1]+" slaps to your balls. Make them good ones.")
	showButton("Ready")
	punish("Slap those balls!", punishments[1],"Slaps", 80)
}
if (punishments[2]>0) {
setPic(2)
	show("Right, no cumming for the next "+punishments[2]+" hours. Hope it doesn't get too frustrating!")
	showButton("OK")
}
}

// Get the current number of counters
def getCurrentPlay = {currentCounters ->
	def currentplay = "X"
	for (def i=2;i<=currentCounters;i++){
		currentplay=currentplay + "  O"
	}
return currentplay
}
def currentplay=getCurrentPlay(counters)

// Remove specified number of counters
def removeCounters = {removechoice,removecounters ->
	def countertextplural =""
	if (removechoice>1) {
		countertextplural="s"
	}
	for (def j=1;j<=removechoice;j++){
		currentplay=getCurrentPlay(removecounters)
		show("Removing "+removechoice+" counter"+countertextplural+"\n\n"+currentplay)
		wait(1)
		removecounters--
	}
currentplay=getCurrentPlay(removecounters)
show("Removing "+removechoice+" counter"+countertextplural+"\n\n"+currentplay)
wait(1)

}

// Comptuter has a go
def CompGo = {CompCounters,PlayerChoice,Skill ->
show("My go.")
wait(1.5)
setPic(1)
	def Compchoice
	if (CompCounters>4) {
	if (getRandom(10)<=Skill) {
			Compchoice=((CompCounters-1)%4)
			if (Compchoice==0) {
				Compchoice=1
				}
			
		} else {
			Compchoice=getRandom(3)+1
		}
	} else {
		Compchoice=CompCounters-1
	}
	def countertextplural =""
	if (Compchoice>1) {
		countertextplural="s"
	}
	switch (getRandom(4)+1) {
		case 1:
			show("I think I'll take "+Compchoice+" counter"+countertextplural+"."); break;
		case 2:
			show("Now I'll take "+Compchoice+" counter"+countertextplural+"."); break;
		case 3:
			show("My turn. "+Compchoice+" counter"+countertextplural+"."); break;
		case 4:
			show("In that case I'll choose "+Compchoice+" counter"+countertextplural+"."); break;
	}
		wait(2)

	removeCounters(Compchoice,CompCounters)
	def remainingcounters=CompCounters-Compchoice
	return remainingcounters

}

// Start function to set game type
def start = {->
	def gameType=2
	while (gameType==2) {
	gameType = getSelectedValue("Let's play a game of Nim. Would you like a practice game or play for real?",["Practice", "Normal","Rules"])
	if (gameType==1) {
   	gameDiff = getSelectedValue("What difficulty would you like to play at? The rewards are less and the consquences higher if you choose an easy game.",["Easy", "Normal","Hard","Impossible"])
	}


	if (gameType==2) {
		show("The game is simple. We will lay out a number of counters, shown as 'O'. At the end is the punishment counter 'X'\n\nWe take it in turns to take up to 3 counters.\n\nThe aim is to NOT end up picking the punishment counter.\n\nI'll warn you though, I am very good.")
		showButton("Got it")
	}
	}
	return gameType
}

def gameType=start()



// Function to make a win/lose deal
def GetDeal = { ->
def PunishChoice
setPic(2)
	if (PunishmentRecord[0] >0 || PunishmentRecord[1] >0  || PunishmentRecord[2] >0 ) {
		winReward=4
	} else if (gameDiff==0) {
		winReward=0
	} else if (gameDiff==2) {
		winReward=2
	} else if (gameDiff==3) {
		winReward=3
	} else {
		winReward=getRandom(2)
	}
	if (winReward==0) {
		winstring="If you do beat me, you'll get to see me naked."
	} else if (winReward==1) {
		winstring="If you do beat me, you'll get to cum."
	} else if (winReward==2) {
		winstring="If you do beat me, you'll get to see me naked and get a chance to cum."
	} else if (winReward==3) {
		winstring="If you do beat me, you'll get to tie me up and gag me naked and then cum watching me!"
	} else {
		winstring="If you win, I'll cancel your outstanding punishments to me."
	}
	def multiplier=2*(3-gameDiff)+gamesplayed
	punishment = [getRandom(50+3*multiplier)+25+3*multiplier, getRandom(25+2*multiplier)+12+2*multiplier, getRandom(36+4*multiplier)+12+4*multiplier]
	PunishChoice = getSelectedValue("Here's the deal. "+winstring+"\n\nBut if I beat you, you have the choice between:\n "+punishment[0]+" spanks to your butt.\n"+punishment[1]+" slaps to your balls.\n"+punishment[2]+" hours of denial.\n\nWhich do you want?",["Butt Spanks", "Ball Slaps", "Denial"])

	PunishmentRecord[PunishChoice]=PunishmentRecord[PunishChoice]+punishment[PunishChoice]
}


// Function for if player wins
def wingame = {winType,DiffLevel ->
	setPic(1)
	if (winType == 0 || winType == 2) {
		show("OK, before I start taking off my clothes I want you naked.\n\nYou are free to play with yourself but remember, NO CUMMING!")
		showButton("Ready")
		show("")
		for (PicNo=1;PicNo<=5;PicNo++) {
			setImage("Nim/Strip"+(PicNo)+".jpg")
			wait(getRandom(2)+1+DiffLevel*2)
		}
		show("Are you enjoying the show?")
		showButton("Yes Mistress")
		if (DiffLevel==0) {
			show("Sorry if its going too fast for you, but I wasn't playing to my full ability.")
			showButton("Next time I'll player on a harder difficulty.")
		}
		show("")
		for (PicNo=6;PicNo<=10;PicNo++) {
			setImage("Nim/Strip"+(PicNo)+".jpg")
			wait(getRandom(2)+1+DiffLevel*2)
		}
		if (winType == 0) {show("Nearly there, I hope you can keep it together.")
		 } else {show("Nearly there. Get ready to cum. It'll only be a small window!")}
		wait(3)
		setImage("Nim/Strip11.jpg")

		if (winType==0) {
		wait(getRandom(2)+1+DiffLevel*2)
			setPic(2)
			show("...and that's all you get. Try playing again for more.")
			showButton("Yes Mistress")
		}
		if (winType==2) {
		setImage("Nim/Strip11.jpg")
		show("OK now's your chance to cum!")
		wait(5+getRandom(5))
		setPic(2)
		show("Time up! I hope you managed to finish.")	
		wait(5)	
		}
}
	if (winType == 1) {
		show("So first get yourself naked and hard.")
		showButton("Ready")
		setPic(2)
		show("Your orders are simple. Just watch me and stroke BUT do not cum until I say.")
		showButton("Yes Mistress")
		show("You will have a small window in which to cum. I hope you manage it then.")
		showButton("Ready Mistress")
		show("Stroke")

def winend=getTime()+getRandom(30)+60
		while (getTime()<winend) {
			if (getRandom(2)<1) {
				setPic(1)
			} else {
				PicNo=getRandom(6)+1
				setImage("Nim/Strip"+(PicNo)+".jpg")		
			}
		wait(getRandom(2)+1+DiffLevel*2)
		}
		setImage("Nim/Strip6.jpg")
		while (getTime()<winend+5+getRandom(5)) {
		show("OK now's your chance to cum!")
		}
		setPic(2)
		show("Time up! I hope you managed to finish.")	
		wait(5)	


	}
		 

}


// Start of main loop for playing game
while (playAgain==1) {

// Set game variables
	counters = setCounters()
	if (gameType==1) {
		GetDeal()
	}
gamesplayed=gamesplayed+1


if (gameType==0) {
	MistressSkill=3
} else if (gameType==1) {
	if (gameDiff==0) {
		MistressSkill=4
	} else if (gameDiff==1) {
		MistressSkill=8
	} else {
		MistressSkill=10
	}
}

currentplay=getCurrentPlay(counters)
show(currentplay)

if (gameDiff==3) {
	if ((counters-1)%4==0) {
		turn=1;
	} else {
		turn=0;
	}
}
if (gameDiff==2) {
	turn=getRandom(2)
}
// Game loop until all counters are gone
while (counters>1) {
	if (turn==1) {
	validIn=0
	while (validIn==0) {
		choice = getInteger("Your turn:\n\n"+currentplay+ "\n\n\n\n How many counters? 1, 2 or 3?",1);
		if (choice==1 || choice==2 || choice ==3) {validIn=1}
		}
		removeCounters(choice,counters)
		counters=counters-choice
		currentplay=getCurrentPlay(counters)
		turn=0
	} else {
		counters = CompGo(counters,choice,MistressSkill)
		currentplay=getCurrentPlay(counters)
		turn=1
	}
	
}


// Ending section for when last counter is taken
if (counters==1) {
if (gameType==0) {
gamesplayed=0
		if (turn==1) {
			setPic(2)
			playAgain=getSelectedValue("X\n\nOh dear, you are left with the punishment counter. You Lose!\n\nLuckilly for you this wasn't a real game.\n\nPlay Again?",["No thanks","Yes Please"])
		} else {
			setPic(2)
			playAgain=getSelectedValue("X\n\nWell done, you beat me.\n\nUnfortunately for you this wasn't a real game.\n\nPlay Again?",["No Thanks","Yes Please"])	
		}
			if (playAgain==1) {gameType=start()}
  
} else {


	if (turn==1) {
setPic(2)
		show("X\n\nOh dear, you are left with the punishment counter. You Lose!")
		showButton("OK")
		losestring="You now owe me:\n"
		if (PunishmentRecord[0]>0) {
			losestring=losestring+PunishmentRecord[0]+" butt spanks.\n"
		}
		if (PunishmentRecord[1]>0) {
			losestring=losestring+PunishmentRecord[1]+" ball slaps.\n"
		}
		if (PunishmentRecord[2]>0) {
			losestring=losestring+PunishmentRecord[2]+" hours of denial.\n"
		}
		if (getRandom(10)<endchance) {
			endchance=endchance-1
			playAgain = getSelectedValue(losestring+"\nHowever, I'll make you an offer. Either you can take your punishment now, or we can play again. If you lose, your new punishment will be added to your outstanding. If you win, I'll cancel it.",["I'll take my punishment now.", "Let's play again."])
} else {
	show(losestring+"\nI'm not going to offer you another chance. Get ready for your punishment.")
	showButton("OK")
	playAgain=0
}
		if (playAgain==0) {
			Finalpunishment(PunishmentRecord)
		} else {
if (MistressSkill<10) {MistressSkill=MistressSkill+1}
		}

	} else {
		switch (winReward) {
			case 0:			
				show("X\n\nIt seems I have lost! You get a chance to see me naked.");showButton("OK");playAgain=0;wingame(winReward,gameDiff); break;
			case 1:			
				show("X\n\nIt seems I have lost! You get a chance to cum then as agreed.");showButton("OK");playAgain=0;wingame(winReward,gameDiff); break;
			case 2:			
				show("X\n\nIt seems I have lost! You get a chance to cum then as agreed.");showButton("OK");playAgain=0;wingame(winReward,gameDiff); break;
			case 4:
				PunishmentRecord = [0,0,0]
				playAgain = getSelectedValue("X\n\nIt seems I have lost! As promised I have canceled your outstanding punishments.\n\nWould you like to keep playing to see if you can beat me again?",["No I'm done.", "Let's play again."]);if (MistressSkill<10) {MistressSkill=MistressSkill+1};break;
		}		
	}
	

	}
	
}

}
	show("I hope you come back for another game.")


// This script, from http://ss.deviatenow.com, is protected by this licence :
// CC BY-SA 4.0, see http://creativecommons.org/licenses/by-sa/4.0/

/*
 * Resources
 * scripts/Nim.groovy
 * images/Nim/Nim1.jpg
 * images/Nim/Nim2.jpg
 * images/Nim/Nim3.jpg
 * images/Nim/Nim4.jpg
 * images/Nim/Nim5.jpg
 * images/Nim/Punish1.jpg
 * images/Nim/Punish2.jpg
 * images/Nim/Punish3.jpg
 * images/Nim/Punish4.jpg
 * images/Nim/Strip1.jpg
 * images/Nim/Strip2.jpg
 * images/Nim/Strip3.jpg
 * images/Nim/Strip4.jpg
 * images/Nim/Strip5.jpg
 * images/Nim/Strip6.jpg
 * images/Nim/Strip7.jpg
 * images/Nim/Strip8.jpg
 * images/Nim/Strip9.jpg
 * images/Nim/Strip10.jpg
 * images/Nim/Strip11.jpg
*/
